import urllib
import base64
import re
import binascii
import md5
import sha


# SUPERCLASS

class encoder:
	def __init__(self):
		pass
	
	def encode (self,string):
		return string


#######################################################
######################################################
######## Inheritances
#######################################################
######################################################

class encoder_urlencode (encoder):
	text="urlencode"
	def __init__(self):
		encoder.__init__(self)

	def encode(self,string):
		return urllib.quote(string)

class encoder_double_urlencode (encoder):
	text="double_urlencode"
	def __init__(self):
		encoder.__init__(self)

	def encode(self,string):
		return urllib.quote(urllib.quote(string))

class encoder_base64 (encoder):
	text="base64"
	def __init__(self):
		encoder.__init__(self)

	def encode(self,string):
		return base64.standard_b64encode(string)

class encoder_uri_hex (encoder):
	text="uri_hex"
	def __init__(self):
		encoder.__init__(self)
	
	def encode(self,string):
		strt = ""
		con = "%%%02x"
		s=re.compile(r"/|;|=|:|&|@|\\|\?")	
		for c in string:
			if s.search(c):
				strt += c
				continue
			strt += con % ord(c)
		return strt


class encoder_random_upper (encoder):
	text="random_upper"
	def __init__(self):
		encoder.__init__(self)
	
	def encode(self,string):
		strt = ""
		for c in string:
			x = int(uniform(0,10))
			x = x % 2
			if x == 1:
				strt += c.upper()
			else:
				strt += c
		return strt   


class encoder_doble_nibble_hex (encoder):
	text="double_nibble_hex"
	def __init__(self):
		encoder.__init__(self)
	
	def encode(self,string):
		strt = ""
		fin = ""
		con = "%%%02x"
# first get it in straight hex
		s=re.compile(r"/|;|=|:|&|@|\\|\?")	
		enc=encoder_uri_hex()
		strt = enc.encode(string)
		for c in strt:
			if not c == "%":
				if s.search(c):
					fin += c
					continue
				fin += con % ord(c)
			else:
				fin += c
		return fin

class encoder_sha1 (encoder):
	text="sha1"
	def __init__(self):
		encoder.__init__(self)

	def encode(self,string):
		s=sha.new()
		s.update(string)
		res =s.hexdigest()
		return res
		
class encoder_md5 (encoder):
	text="md5"
	def __init__(self):
		encoder.__init__(self)

	def encode(self,string):
		m=md5.new()
		m.update(string)
		res = m.hexdigest()
		return res
		
class encoder_binascii (encoder):
	text="bin_ascii"
	def __init__(self):
		encoder.__init__(self)

	def encode(self,string):
		res = binascii.hexlify(stringy)		
		return res
